<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - coverage.info - prbs/tb_vunit_prbs.vhd</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">prbs</a> - tb_vunit_prbs.vhd<span style="font-size: 80%;"> (source / <a href="tb_vunit_prbs.vhd.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">coverage.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">145</td>
            <td class="headerCovTableEntry">145</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2023-02-09 12:58:45</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">21</td>
            <td class="headerCovTableEntry">23</td>
            <td class="headerCovTableEntryHi">91.3 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span><span class="lineCov">         12 : library ieee;</span></a>
<a name="2"><span class="lineNum">       2 </span>            : use ieee.std_logic_1164.all;</a>
<a name="3"><span class="lineNum">       3 </span>            : use ieee.numeric_std.all;</a>
<a name="4"><span class="lineNum">       4 </span>            : </a>
<a name="5"><span class="lineNum">       5 </span>            : library src_lib;</a>
<a name="6"><span class="lineNum">       6 </span>            : --</a>
<a name="7"><span class="lineNum">       7 </span><span class="lineCov">          4 : library vunit_lib;</span></a>
<a name="8"><span class="lineNum">       8 </span><span class="lineCov">          4 : context vunit_lib.vunit_context;</span></a>
<a name="9"><span class="lineNum">       9 </span><span class="lineCov">          4 : context vunit_lib.com_context;</span></a>
<a name="10"><span class="lineNum">      10 </span><span class="lineCov">          4 : </span></a>
<a name="11"><span class="lineNum">      11 </span>            : library osvvm;</a>
<a name="12"><span class="lineNum">      12 </span>            : use osvvm.randompkg.all;</a>
<a name="13"><span class="lineNum">      13 </span>            : use osvvm.coveragepkg.all;</a>
<a name="14"><span class="lineNum">      14 </span>            : </a>
<a name="15"><span class="lineNum">      15 </span>            : </a>
<a name="16"><span class="lineNum">      16 </span><span class="lineCov">        830 : entity prbs_vunit_tb is</span></a>
<a name="17"><span class="lineNum">      17 </span>            :   generic (runner_cfg : string);</a>
<a name="18"><span class="lineNum">      18 </span>            : end;</a>
<a name="19"><span class="lineNum">      19 </span>            : </a>
<a name="20"><span class="lineNum">      20 </span>            : architecture bench_vunit of prbs_vunit_tb is</a>
<a name="21"><span class="lineNum">      21 </span>            : </a>
<a name="22"><span class="lineNum">      22 </span>            : </a>
<a name="23"><span class="lineNum">      23 </span>            :   -- Clock period</a>
<a name="24"><span class="lineNum">      24 </span><span class="lineCov">          4 :   constant clk_period : time := 5 ns;</span></a>
<a name="25"><span class="lineNum">      25 </span>            :   -- Generics</a>
<a name="26"><span class="lineNum">      26 </span>            : </a>
<a name="27"><span class="lineNum">      27 </span>            :   -- Ports</a>
<a name="28"><span class="lineNum">      28 </span><span class="lineCov">          4 :   signal clk : std_ulogic;</span></a>
<a name="29"><span class="lineNum">      29 </span><span class="lineCov">          4 :   signal reset : std_ulogic;</span></a>
<a name="30"><span class="lineNum">      30 </span><span class="lineCov">          4 :   signal enable : std_ulogic;</span></a>
<a name="31"><span class="lineNum">      31 </span><span class="lineCov">          4 :   signal output : std_ulogic;</span></a>
<a name="32"><span class="lineNum">      32 </span>            : </a>
<a name="33"><span class="lineNum">      33 </span>            :   type input_tran_t is record</a>
<a name="34"><span class="lineNum">      34 </span>            :     reset   : boolean;</a>
<a name="35"><span class="lineNum">      35 </span>            :     enable  : boolean;</a>
<a name="36"><span class="lineNum">      36 </span>            :     cycles  : integer;</a>
<a name="37"><span class="lineNum">      37 </span>            :   end record;</a>
<a name="38"><span class="lineNum">      38 </span>            : </a>
<a name="39"><span class="lineNum">      39 </span>            :   type output_tran_t is record</a>
<a name="40"><span class="lineNum">      40 </span>            :     value : integer;  </a>
<a name="41"><span class="lineNum">      41 </span>            :   end record;</a>
<a name="42"><span class="lineNum">      42 </span>            : </a>
<a name="43"><span class="lineNum">      43 </span><span class="lineCov">          4 :   signal running : boolean := true;</span></a>
<a name="44"><span class="lineNum">      44 </span>            : </a>
<a name="45"><span class="lineNum">      45 </span>            :   -- Since VUnit's communication library only allows to push and pop simple</a>
<a name="46"><span class="lineNum">      46 </span>            :   -- datatypes, we'll define our own procedures to push and pop complete</a>
<a name="47"><span class="lineNum">      47 </span>            :   -- transactions, using the already-defined push and pop procedures</a>
<a name="48"><span class="lineNum">      48 </span>            :   -- We will also define our own to_string() functions for debugging purposes</a>
<a name="49"><span class="lineNum">      49 </span><span class="lineCov">       6480 :   procedure push(msg: msg_t; input_tran: input_tran_t) is</span></a>
<a name="50"><span class="lineNum">      50 </span>            :   begin</a>
<a name="51"><span class="lineNum">      51 </span><span class="lineCov">       1620 :     push(msg, input_tran.reset);</span></a>
<a name="52"><span class="lineNum">      52 </span><span class="lineCov">       1620 :     push(msg, input_tran.enable);</span></a>
<a name="53"><span class="lineNum">      53 </span><span class="lineCov">       8100 :     push(msg, input_tran.cycles);</span></a>
<a name="54"><span class="lineNum">      54 </span>            :   end procedure;</a>
<a name="55"><span class="lineNum">      55 </span>            : </a>
<a name="56"><span class="lineNum">      56 </span>            :   -- Impure functions can read and write out of their scope, they have</a>
<a name="57"><span class="lineNum">      57 </span>            :   -- 'side effects'. Our 'pop' must be impure since it calls VUnit's 'pop'</a>
<a name="58"><span class="lineNum">      58 </span>            :   -- functions, which are impure themselves</a>
<a name="59"><span class="lineNum">      59 </span>            :   impure function pop(msg: msg_t) return input_tran_t is</a>
<a name="60"><span class="lineNum">      60 </span><span class="lineCov">       1620 :     variable input_tran : input_tran_t;</span></a>
<a name="61"><span class="lineNum">      61 </span>            :   begin</a>
<a name="62"><span class="lineNum">      62 </span><span class="lineCov">       1620 :     input_tran.reset  := pop(msg);</span></a>
<a name="63"><span class="lineNum">      63 </span><span class="lineCov">       1620 :     input_tran.enable := pop(msg);</span></a>
<a name="64"><span class="lineNum">      64 </span><span class="lineCov">       1620 :     input_tran.cycles := pop(msg);</span></a>
<a name="65"><span class="lineNum">      65 </span><span class="lineCov">       1620 :     return input_tran;</span></a>
<a name="66"><span class="lineNum">      66 </span>            :   end function;</a>
<a name="67"><span class="lineNum">      67 </span>            : </a>
<a name="68"><span class="lineNum">      68 </span>            :   function to_string(input_tran: input_tran_t) return string is</a>
<a name="69"><span class="lineNum">      69 </span>            :   begin</a>
<a name="70"><span class="lineNum">      70 </span><span class="lineCov">       1620 :     return &quot;[input_tran] (reset =&gt; &quot; &amp; to_string(input_tran.reset) &amp; &quot;, enable =&gt; &quot; &amp; to_string(input_tran.enable) &amp; &quot;, cycles =&gt; &quot; &amp; to_string(input_tran.cycles) &amp; &quot;)&quot;; </span></a>
<a name="71"><span class="lineNum">      71 </span>            :   end function;</a>
<a name="72"><span class="lineNum">      72 </span>            : </a>
<a name="73"><span class="lineNum">      73 </span><span class="lineCov">       4696 :   procedure push(msg: msg_t; output_tran: output_tran_t) is</span></a>
<a name="74"><span class="lineNum">      74 </span>            :   begin</a>
<a name="75"><span class="lineNum">      75 </span><span class="lineCov">       4696 :     push(msg, output_tran.value);</span></a>
<a name="76"><span class="lineNum">      76 </span>            :   end procedure;</a>
<a name="77"><span class="lineNum">      77 </span>            : </a>
<a name="78"><span class="lineNum">      78 </span>            :   impure function pop(msg: msg_t) return output_tran_t is</a>
<a name="79"><span class="lineNum">      79 </span><span class="lineCov">       1174 :     variable output_tran : output_tran_t;</span></a>
<a name="80"><span class="lineNum">      80 </span>            :   begin</a>
<a name="81"><span class="lineNum">      81 </span><span class="lineCov">       1174 :     output_tran.value := pop(msg);</span></a>
<a name="82"><span class="lineNum">      82 </span><span class="lineCov">       1174 :     return output_tran;</span></a>
<a name="83"><span class="lineNum">      83 </span>            :   end function;</a>
<a name="84"><span class="lineNum">      84 </span>            : </a>
<a name="85"><span class="lineNum">      85 </span>            :   function to_string(output_tran: output_tran_t) return string is</a>
<a name="86"><span class="lineNum">      86 </span>            :   begin</a>
<a name="87"><span class="lineNum">      87 </span><span class="lineCov">       1174 :     return &quot;[output_tran] (value =&gt; &quot; &amp; to_string(output_tran.value) &amp; &quot;)&quot;;</span></a>
<a name="88"><span class="lineNum">      88 </span>            :   end function;</a>
<a name="89"><span class="lineNum">      89 </span>            : </a>
<a name="90"><span class="lineNum">      90 </span>            :   -- Message receivers, one for each entity that will receive transactions</a>
<a name="91"><span class="lineNum">      91 </span>            :   -- The checker has two receivers, so it can easily differentiate between</a>
<a name="92"><span class="lineNum">      92 </span>            :   -- actual and expected transactions</a>
<a name="93"><span class="lineNum">      93 </span><span class="lineCov">          4 :   constant driver_receiver : actor_t := new_actor(&quot;driver receiver&quot;);</span></a>
<a name="94"><span class="lineNum">      94 </span><span class="lineCov">          4 :   constant predictor_receiver : actor_t := new_actor(&quot;predictor receiver&quot;);</span></a>
<a name="95"><span class="lineNum">      95 </span><span class="lineCov">          4 :   constant checker_receiver_actual : actor_t := new_actor(&quot;checker receiver actual&quot;);</span></a>
<a name="96"><span class="lineNum">      96 </span><span class="lineCov">          4 :   constant checker_receiver_expected : actor_t := new_actor(&quot;checker receiver expected&quot;);</span></a>
<a name="97"><span class="lineNum">      97 </span>            : </a>
<a name="98"><span class="lineNum">      98 </span>            :   -- For functional coverage:</a>
<a name="99"><span class="lineNum">      99 </span><span class="lineCov">          4 :   constant coverage_receiver_input : actor_t := new_actor(&quot;coverage receiver input&quot;);</span></a>
<a name="100"><span class="lineNum">     100 </span><span class="lineCov">          4 :   constant coverage_receiver_output : actor_t := new_actor(&quot;coverage receiver output&quot;);</span></a>
<a name="101"><span class="lineNum">     101 </span>            : </a>
<a name="102"><span class="lineNum">     102 </span>            :   -- Objects for functional coverage</a>
<a name="103"><span class="lineNum">     103 </span><span class="lineCov">          4 :   signal cover_reset: CoverageIDtype := NewID(&quot;cover_reset&quot;);</span></a>
<a name="104"><span class="lineNum">     104 </span><span class="lineCov">          4 :   signal cover_enable: CoverageIDtype := NewID(&quot;cover_ena&quot;);</span></a>
<a name="105"><span class="lineNum">     105 </span><span class="lineCov">          4 :   signal cover_cycles: CoverageIDtype := NewID(&quot;cover_cycles&quot;);</span></a>
<a name="106"><span class="lineNum">     106 </span><span class="lineCov">          8 :   signal cover_value: CoverageIDtype := NewID(&quot;cover_value&quot;);</span></a>
<a name="107"><span class="lineNum">     107 </span>            : </a>
<a name="108"><span class="lineNum">     108 </span>            : </a>
<a name="109"><span class="lineNum">     109 </span>            : begin</a>
<a name="110"><span class="lineNum">     110 </span>            : </a>
<a name="111"><span class="lineNum">     111 </span><span class="lineCov">          4 :   prbs_inst : entity src_lib.prbs</span></a>
<a name="112"><span class="lineNum">     112 </span>            :     port map (</a>
<a name="113"><span class="lineNum">     113 </span>            :       clk =&gt; clk,</a>
<a name="114"><span class="lineNum">     114 </span>            :       reset =&gt; reset,</a>
<a name="115"><span class="lineNum">     115 </span>            :       enable =&gt; enable,</a>
<a name="116"><span class="lineNum">     116 </span>            :       output =&gt; output</a>
<a name="117"><span class="lineNum">     117 </span>            :     );</a>
<a name="118"><span class="lineNum">     118 </span>            : </a>
<a name="119"><span class="lineNum">     119 </span><span class="lineCov">         20 :   main : process</span></a>
<a name="120"><span class="lineNum">     120 </span>            : </a>
<a name="121"><span class="lineNum">     121 </span><span class="lineCov">      11340 :     procedure seq_tran(constant input_tran: in input_tran_t) is</span></a>
<a name="122"><span class="lineNum">     122 </span><span class="lineCov">        810 :       variable msg : msg_t;</span></a>
<a name="123"><span class="lineNum">     123 </span><span class="lineCov">        810 :       variable msg_copy : msg_t;</span></a>
<a name="124"><span class="lineNum">     124 </span><span class="lineCov">        810 :       variable msg_copy_cover: msg_t;</span></a>
<a name="125"><span class="lineNum">     125 </span>            :     begin</a>
<a name="126"><span class="lineNum">     126 </span><span class="lineCov">       1620 :       info(&quot;test_sequence: pushing:&quot; &amp; to_string(input_tran));</span></a>
<a name="127"><span class="lineNum">     127 </span><span class="lineCov">        810 :       msg := new_msg;</span></a>
<a name="128"><span class="lineNum">     128 </span><span class="lineCov">       1620 :       push(msg, input_tran);</span></a>
<a name="129"><span class="lineNum">     129 </span><span class="lineCov">        810 :       msg_copy := copy(msg);</span></a>
<a name="130"><span class="lineNum">     130 </span><span class="lineCov">        810 :       msg_copy_cover := copy(msg);</span></a>
<a name="131"><span class="lineNum">     131 </span><span class="lineCov">       2430 :       send(net, driver_receiver, msg);</span></a>
<a name="132"><span class="lineNum">     132 </span><span class="lineCov">       1620 :       send(net, predictor_receiver, msg_copy);</span></a>
<a name="133"><span class="lineNum">     133 </span><span class="lineCov">       1620 :       send(net, coverage_receiver_input, msg_copy_cover);</span></a>
<a name="134"><span class="lineNum">     134 </span><span class="lineCov">      14668 :       wait for input_tran.cycles*clk_period;</span></a>
<a name="135"><span class="lineNum">     135 </span>            :     end procedure;</a>
<a name="136"><span class="lineNum">     136 </span>            : </a>
<a name="137"><span class="lineNum">     137 </span>            : </a>
<a name="138"><span class="lineNum">     138 </span>            :   begin</a>
<a name="139"><span class="lineNum">     139 </span><span class="lineCov">         12 :     test_runner_setup(runner, runner_cfg);</span></a>
<a name="140"><span class="lineNum">     140 </span>            :     </a>
<a name="141"><span class="lineNum">     141 </span><span class="lineCov">         12 :     while test_suite loop</span></a>
<a name="142"><span class="lineNum">     142 </span>            : </a>
<a name="143"><span class="lineNum">     143 </span>            :    </a>
<a name="144"><span class="lineNum">     144 </span><span class="lineCov">          4 :     if run(&quot;test_reset&quot;) then</span></a>
<a name="145"><span class="lineNum">     145 </span><span class="lineCov">          2 :       info(&quot;counter: test_reset&quot;);</span></a>
<a name="146"><span class="lineNum">     146 </span>            :       -- Test sequence for test_reset</a>
<a name="147"><span class="lineNum">     147 </span><span class="lineCov">          4 :       seq_tran((reset =&gt; true, enable =&gt; false, cycles =&gt; 1));</span></a>
<a name="148"><span class="lineNum">     148 </span><span class="lineCov">          5 :       seq_tran((reset =&gt; false, enable =&gt; true, cycles =&gt; 100));</span></a>
<a name="149"><span class="lineNum">     149 </span>            : </a>
<a name="150"><span class="lineNum">     150 </span><span class="lineCov">          3 :     elsif run(&quot;test_overflow&quot;) then</span></a>
<a name="151"><span class="lineNum">     151 </span><span class="lineCov">          2 :       info(&quot;counter: test_overflow&quot;);</span></a>
<a name="152"><span class="lineNum">     152 </span>            : </a>
<a name="153"><span class="lineNum">     153 </span><span class="lineCov">          4 :       seq_tran((reset =&gt; true, enable =&gt; false, cycles =&gt; 1));</span></a>
<a name="154"><span class="lineNum">     154 </span><span class="lineCov">          5 :       seq_tran((reset =&gt; false, enable =&gt; true, cycles =&gt; 258));</span></a>
<a name="155"><span class="lineNum">     155 </span>            : </a>
<a name="156"><span class="lineNum">     156 </span><span class="lineCov">          5 :     elsif run(&quot;test_alternating_ena&quot;) then</span></a>
<a name="157"><span class="lineNum">     157 </span><span class="lineCov">          4 :       info(&quot;counter: test_alternating_enable&quot;);</span></a>
<a name="158"><span class="lineNum">     158 </span>            :      </a>
<a name="159"><span class="lineNum">     159 </span><span class="lineCov">          8 :       seq_tran((reset =&gt; true, enable =&gt; false, cycles =&gt; 1));</span></a>
<a name="160"><span class="lineNum">     160 </span>            : </a>
<a name="161"><span class="lineNum">     161 </span><span class="lineCov">          2 :       for i in 0 to 200 loop</span></a>
<a name="162"><span class="lineNum">     162 </span><span class="lineCov">       1608 :         seq_tran((reset =&gt; false, enable =&gt; true, cycles =&gt; 1));</span></a>
<a name="163"><span class="lineNum">     163 </span><span class="lineCov">       2418 :         seq_tran((reset =&gt; false, enable =&gt; false, cycles =&gt; 1));</span></a>
<a name="164"><span class="lineNum">     164 </span>            :       end loop;</a>
<a name="165"><span class="lineNum">     165 </span>            :     </a>
<a name="166"><span class="lineNum">     166 </span>            :     end if;</a>
<a name="167"><span class="lineNum">     167 </span>            : </a>
<a name="168"><span class="lineNum">     168 </span>            :   end loop;</a>
<a name="169"><span class="lineNum">     169 </span><span class="lineCov">          4 :     running &lt;= false;</span></a>
<a name="170"><span class="lineNum">     170 </span><span class="lineCov">          4 :     wait for 10 ns;</span></a>
<a name="171"><span class="lineNum">     171 </span>            :     -- Print functional coverage</a>
<a name="172"><span class="lineNum">     172 </span><span class="lineCov">          8 :     writebin(cover_reset);</span></a>
<a name="173"><span class="lineNum">     173 </span><span class="lineCov">          8 :     writebin(cover_enable);</span></a>
<a name="174"><span class="lineNum">     174 </span><span class="lineCov">          8 :     writebin(cover_cycles);</span></a>
<a name="175"><span class="lineNum">     175 </span><span class="lineCov">          8 :     writebin(cover_value);</span></a>
<a name="176"><span class="lineNum">     176 </span>            : </a>
<a name="177"><span class="lineNum">     177 </span><span class="lineCov">       6036 :     test_runner_cleanup(runner);</span></a>
<a name="178"><span class="lineNum">     178 </span>            :   </a>
<a name="179"><span class="lineNum">     179 </span>            :   end process main;</a>
<a name="180"><span class="lineNum">     180 </span>            : </a>
<a name="181"><span class="lineNum">     181 </span><span class="lineCov">          4 :   clk_process : process</span></a>
<a name="182"><span class="lineNum">     182 </span>            :   begin</a>
<a name="183"><span class="lineNum">     183 </span><span class="lineCov">       1178 :   clk &lt;= '1';</span></a>
<a name="184"><span class="lineNum">     184 </span><span class="lineCov">       1178 :   wait for clk_period/2;</span></a>
<a name="185"><span class="lineNum">     185 </span><span class="lineCov">       1174 :   clk &lt;= '0';</span></a>
<a name="186"><span class="lineNum">     186 </span><span class="lineCov">      13168 :   wait for clk_period/2;</span></a>
<a name="187"><span class="lineNum">     187 </span>            :   end process clk_process;</a>
<a name="188"><span class="lineNum">     188 </span>            : </a>
<a name="189"><span class="lineNum">     189 </span><span class="lineCov">          4 :   driver: process</span></a>
<a name="190"><span class="lineNum">     190 </span><span class="lineCov">          4 :     variable msg: msg_t;</span></a>
<a name="191"><span class="lineNum">     191 </span><span class="lineCov">          4 :     variable input_tran: input_tran_t; </span></a>
<a name="192"><span class="lineNum">     192 </span>            :   begin</a>
<a name="193"><span class="lineNum">     193 </span><span class="lineCov">       1628 :     info(&quot;driver: waiting for transaction...&quot;);</span></a>
<a name="194"><span class="lineNum">     194 </span><span class="lineCov">       2454 :     receive(net, driver_receiver, msg);</span></a>
<a name="195"><span class="lineNum">     195 </span><span class="lineCov">        810 :     input_tran := pop(msg);</span></a>
<a name="196"><span class="lineNum">     196 </span><span class="lineCov">       1620 :     info(&quot;driver: received:&quot; &amp; to_string(input_tran));</span></a>
<a name="197"><span class="lineNum">     197 </span>            : </a>
<a name="198"><span class="lineNum">     198 </span><span class="lineCov">        810 :     if input_tran.reset then</span></a>
<a name="199"><span class="lineNum">     199 </span><span class="lineCov">          4 :       reset &lt;= '1';</span></a>
<a name="200"><span class="lineNum">     200 </span>            :     else</a>
<a name="201"><span class="lineNum">     201 </span><span class="lineCov">        806 :       reset &lt;= '0';</span></a>
<a name="202"><span class="lineNum">     202 </span>            :     end if;</a>
<a name="203"><span class="lineNum">     203 </span>            : </a>
<a name="204"><span class="lineNum">     204 </span><span class="lineCov">        810 :     if input_tran.enable then</span></a>
<a name="205"><span class="lineNum">     205 </span><span class="lineCov">        404 :       enable &lt;= '1';</span></a>
<a name="206"><span class="lineNum">     206 </span>            :     else</a>
<a name="207"><span class="lineNum">     207 </span><span class="lineCov">        406 :       enable &lt;= '0';</span></a>
<a name="208"><span class="lineNum">     208 </span>            :     end if;</a>
<a name="209"><span class="lineNum">     209 </span>            : </a>
<a name="210"><span class="lineNum">     210 </span><span class="lineCov">        810 :     for i in 1 to input_tran.cycles loop</span></a>
<a name="211"><span class="lineNum">     211 </span><span class="lineCov">      25256 :       wait for clk_period;</span></a>
<a name="212"><span class="lineNum">     212 </span>            :     end loop;</a>
<a name="213"><span class="lineNum">     213 </span>            :   end process;</a>
<a name="214"><span class="lineNum">     214 </span>            : </a>
<a name="215"><span class="lineNum">     215 </span>            : </a>
<a name="216"><span class="lineNum">     216 </span><span class="lineCov">          4 :   monitor: process</span></a>
<a name="217"><span class="lineNum">     217 </span><span class="lineCov">          4 :     variable msg: msg_t;</span></a>
<a name="218"><span class="lineNum">     218 </span><span class="lineCov">          4 :     variable output_tran: output_tran_t;</span></a>
<a name="219"><span class="lineNum">     219 </span><span class="lineCov">          4 :     variable msg_copy_cover: msg_t; </span></a>
<a name="220"><span class="lineNum">     220 </span><span class="lineCov">          8 :     variable out_helper: std_logic_vector(0 downto 0);</span></a>
<a name="221"><span class="lineNum">     221 </span>            :   begin</a>
<a name="222"><span class="lineNum">     222 </span><span class="lineCov">       4700 :     wait until falling_edge(clk);</span></a>
<a name="223"><span class="lineNum">     223 </span><span class="lineCov">       1174 :     out_helper(0) := output; </span></a>
<a name="224"><span class="lineNum">     224 </span><span class="lineCov">       1174 :     output_tran.value := to_integer(unsigned(out_helper));</span></a>
<a name="225"><span class="lineNum">     225 </span><span class="lineCov">       2348 :     info(&quot;monitor: detected:&quot; &amp; to_string(output_tran));</span></a>
<a name="226"><span class="lineNum">     226 </span><span class="lineCov">       1174 :     msg := new_msg;</span></a>
<a name="227"><span class="lineNum">     227 </span><span class="lineCov">       2348 :     push(msg, output_tran);</span></a>
<a name="228"><span class="lineNum">     228 </span><span class="lineCov">       1174 :     msg_copy_cover := copy(msg);</span></a>
<a name="229"><span class="lineNum">     229 </span><span class="lineCov">       3522 :     send(net, checker_receiver_actual, msg);</span></a>
<a name="230"><span class="lineNum">     230 </span><span class="lineCov">      21074 :     send(net, coverage_receiver_output, msg_copy_cover);</span></a>
<a name="231"><span class="lineNum">     231 </span>            :   end process;</a>
<a name="232"><span class="lineNum">     232 </span>            : </a>
<a name="233"><span class="lineNum">     233 </span><span class="lineCov">          4 :   printer: process</span></a>
<a name="234"><span class="lineNum">     234 </span><span class="lineCov">          4 :     variable outputs : integer_array_t;</span></a>
<a name="235"><span class="lineNum">     235 </span>            :     begin</a>
<a name="236"><span class="lineNum">     236 </span>            : </a>
<a name="237"><span class="lineNum">     237 </span><span class="lineCov">          4 :       outputs := new_1d;</span></a>
<a name="238"><span class="lineNum">     238 </span>            : </a>
<a name="239"><span class="lineNum">     239 </span>            :     -- While the simulation is running, append output data to our output vector</a>
<a name="240"><span class="lineNum">     240 </span><span class="lineCov">       1178 :     while (running) loop</span></a>
<a name="241"><span class="lineNum">     241 </span><span class="lineCov">       4680 :       wait until falling_edge(clk);</span></a>
<a name="242"><span class="lineNum">     242 </span><span class="lineCov">       1170 :         if enable = '1' then</span></a>
<a name="243"><span class="lineNum">     243 </span><span class="lineCov">       3456 :         append(outputs, to_integer(unsigned'('0' &amp; output)));</span></a>
<a name="244"><span class="lineNum">     244 </span>            :         end if;</a>
<a name="245"><span class="lineNum">     245 </span>            :     end loop;</a>
<a name="246"><span class="lineNum">     246 </span>            : </a>
<a name="247"><span class="lineNum">     247 </span>            :     -- When no more clock cycles are expected, write the file and free the</a>
<a name="248"><span class="lineNum">     248 </span>            :     -- memory used for the output vector</a>
<a name="249"><span class="lineNum">     249 </span><span class="lineCov">          8 :     save_csv(outputs,&quot;prbs.csv&quot;);</span></a>
<a name="250"><span class="lineNum">     250 </span><span class="lineCov">          8 :     deallocate(outputs);</span></a>
<a name="251"><span class="lineNum">     251 </span><span class="lineCov">       6994 :     wait;</span></a>
<a name="252"><span class="lineNum">     252 </span>            :   end process;</a>
<a name="253"><span class="lineNum">     253 </span>            : </a>
<a name="254"><span class="lineNum">     254 </span>            : </a>
<a name="255"><span class="lineNum">     255 </span>            : </a>
<a name="256"><span class="lineNum">     256 </span>            :   -- predictor: process</a>
<a name="257"><span class="lineNum">     257 </span>            :   --   variable input_tran: input_tran_t;</a>
<a name="258"><span class="lineNum">     258 </span>            :   --   variable expected_output_tran: output_tran_t;</a>
<a name="259"><span class="lineNum">     259 </span>            :   --   variable expected_output: integer;</a>
<a name="260"><span class="lineNum">     260 </span>            :   --   variable msg: msg_t;</a>
<a name="261"><span class="lineNum">     261 </span>            :     </a>
<a name="262"><span class="lineNum">     262 </span>            :   --   variable p_psb, psb: std_logic_vector(10 downto 0);</a>
<a name="263"><span class="lineNum">     263 </span>            :   --   variable transform: std_logic_vector(0 downto 0);</a>
<a name="264"><span class="lineNum">     264 </span>            :   -- begin</a>
<a name="265"><span class="lineNum">     265 </span>            :   --   psb := (OTHERS =&gt; '1');</a>
<a name="266"><span class="lineNum">     266 </span>            :     </a>
<a name="267"><span class="lineNum">     267 </span>            :   --   while true loop</a>
<a name="268"><span class="lineNum">     268 </span>            :       </a>
<a name="269"><span class="lineNum">     269 </span>            :   --     receive(net, predictor_receiver, msg);</a>
<a name="270"><span class="lineNum">     270 </span>            :   --     input_tran := pop(msg);</a>
<a name="271"><span class="lineNum">     271 </span>            :   --     info(&quot;predictor: input:&quot; &amp; to_string(input_tran));</a>
<a name="272"><span class="lineNum">     272 </span>            : </a>
<a name="273"><span class="lineNum">     273 </span>            :      </a>
<a name="274"><span class="lineNum">     274 </span>            : </a>
<a name="275"><span class="lineNum">     275 </span>            :   --     for i in 0 to input_tran.cycles loop</a>
<a name="276"><span class="lineNum">     276 </span>            :   --       transform := psb(10);</a>
<a name="277"><span class="lineNum">     277 </span>            :   --       expected_output := to_integer(unsigned(transform));</a>
<a name="278"><span class="lineNum">     278 </span>            :   --       if input_tran.reset then</a>
<a name="279"><span class="lineNum">     279 </span>            :   --         expected_output := 1;</a>
<a name="280"><span class="lineNum">     280 </span>            :   --       elsif input_tran.enable then</a>
<a name="281"><span class="lineNum">     281 </span>            :   --         p_psb(10 downto 1) := psb(9 downto 0);</a>
<a name="282"><span class="lineNum">     282 </span>            :   --         p_psb(0) := psb(10) XOR psb(8);        </a>
<a name="283"><span class="lineNum">     283 </span>            :   --       end if;</a>
<a name="284"><span class="lineNum">     284 </span>            :   --       -- Create the output transaction and send it to the checker</a>
<a name="285"><span class="lineNum">     285 </span>            :   --       expected_output_tran.value := expected_output;</a>
<a name="286"><span class="lineNum">     286 </span>            :   --       info(&quot;predictor: expected:&quot; &amp; to_string(expected_output_tran));</a>
<a name="287"><span class="lineNum">     287 </span>            :   --       msg := new_msg;</a>
<a name="288"><span class="lineNum">     288 </span>            :   --       push(msg, expected_output_tran);</a>
<a name="289"><span class="lineNum">     289 </span>            :   --       send(net, checker_receiver_expected, msg);</a>
<a name="290"><span class="lineNum">     290 </span>            :   --     end loop;</a>
<a name="291"><span class="lineNum">     291 </span>            :   --   end loop;</a>
<a name="292"><span class="lineNum">     292 </span>            : </a>
<a name="293"><span class="lineNum">     293 </span>            :   -- end process;</a>
<a name="294"><span class="lineNum">     294 </span>            : </a>
<a name="295"><span class="lineNum">     295 </span>            :   -- checker: process</a>
<a name="296"><span class="lineNum">     296 </span>            :   --   variable msg_actual: msg_t;</a>
<a name="297"><span class="lineNum">     297 </span>            :   --   variable msg_expected: msg_t;</a>
<a name="298"><span class="lineNum">     298 </span>            :   --   variable output_tran_actual: output_tran_t;</a>
<a name="299"><span class="lineNum">     299 </span>            :   --   variable output_tran_expected: output_tran_t;</a>
<a name="300"><span class="lineNum">     300 </span>            :   -- begin</a>
<a name="301"><span class="lineNum">     301 </span>            :   --   -- Wait for both actual and expected output transactions</a>
<a name="302"><span class="lineNum">     302 </span>            :   --   receive(net, checker_receiver_actual, msg_actual);</a>
<a name="303"><span class="lineNum">     303 </span>            :   --   receive(net, checker_receiver_expected, msg_expected);</a>
<a name="304"><span class="lineNum">     304 </span>            :   --   -- Extract the transactions from the message</a>
<a name="305"><span class="lineNum">     305 </span>            :   --   output_tran_actual := pop(msg_actual);</a>
<a name="306"><span class="lineNum">     306 </span>            :   --   output_tran_expected := pop(msg_expected);</a>
<a name="307"><span class="lineNum">     307 </span>            :   --   info(&quot;checker: actual:&quot; &amp; to_string(output_tran_actual));</a>
<a name="308"><span class="lineNum">     308 </span>            :   --   info(&quot;checker: expected:&quot; &amp; to_string(output_tran_expected));</a>
<a name="309"><span class="lineNum">     309 </span>            :   --   -- Check transactions match</a>
<a name="310"><span class="lineNum">     310 </span>            :   --   check(output_tran_actual.value = output_tran_expected.value, &quot;checker: actual value (&quot; &amp; to_string(output_tran_actual.value) &amp; &quot;) and expected value (&quot; &amp; to_string(output_tran_expected.value) &amp; &quot;) must be equal&quot;);</a>
<a name="311"><span class="lineNum">     311 </span>            :   -- end process;</a>
<a name="312"><span class="lineNum">     312 </span>            : </a>
<a name="313"><span class="lineNum">     313 </span>            :   </a>
<a name="314"><span class="lineNum">     314 </span><span class="lineCov">          4 :   coverage_input: process</span></a>
<a name="315"><span class="lineNum">     315 </span><span class="lineCov">          4 :     variable msg: msg_t;</span></a>
<a name="316"><span class="lineNum">     316 </span><span class="lineCov">          4 :     variable input_tran: input_tran_t;</span></a>
<a name="317"><span class="lineNum">     317 </span>            : </a>
<a name="318"><span class="lineNum">     318 </span>            :     function bool2int (bool: boolean) return integer is</a>
<a name="319"><span class="lineNum">     319 </span><span class="lineCov">       1620 :       variable retval : integer;</span></a>
<a name="320"><span class="lineNum">     320 </span>            :     begin</a>
<a name="321"><span class="lineNum">     321 </span><span class="lineCov">       1620 :       if bool then</span></a>
<a name="322"><span class="lineNum">     322 </span><span class="lineCov">        408 :         retval := 1;</span></a>
<a name="323"><span class="lineNum">     323 </span>            :       else</a>
<a name="324"><span class="lineNum">     324 </span><span class="lineCov">       1212 :         retval := 0;</span></a>
<a name="325"><span class="lineNum">     325 </span>            :       end if;</a>
<a name="326"><span class="lineNum">     326 </span><span class="lineCov">      13728 :       return retval;</span></a>
<a name="327"><span class="lineNum">     327 </span>            :     end;</a>
<a name="328"><span class="lineNum">     328 </span>            : </a>
<a name="329"><span class="lineNum">     329 </span>            :   begin</a>
<a name="330"><span class="lineNum">     330 </span><span class="lineCov">          8 :     AddBins(cover_reset, GenBin(0,1));</span></a>
<a name="331"><span class="lineNum">     331 </span><span class="lineCov">          8 :     AddBins(cover_enable, GenBin(0,1));</span></a>
<a name="332"><span class="lineNum">     332 </span><span class="lineCov">          8 :     AddBins(cover_cycles, GenBin(0,511,4));</span></a>
<a name="333"><span class="lineNum">     333 </span><span class="lineCov">        818 :     while true loop</span></a>
<a name="334"><span class="lineNum">     334 </span><span class="lineCov">       5596 :       receive(net, coverage_receiver_input, msg);</span></a>
<a name="335"><span class="lineNum">     335 </span><span class="lineCov">        810 :       input_tran := pop(msg);</span></a>
<a name="336"><span class="lineNum">     336 </span><span class="lineCov">       1620 :       icover(cover_reset, bool2int(input_tran.reset));</span></a>
<a name="337"><span class="lineNum">     337 </span><span class="lineCov">       1620 :       icover(cover_enable, bool2int(input_tran.enable));</span></a>
<a name="338"><span class="lineNum">     338 </span><span class="lineCov">      19172 :       icover(cover_cycles, input_tran.cycles);</span></a>
<a name="339"><span class="lineNum">     339 </span>            :     end loop;</a>
<a name="340"><span class="lineNum">     340 </span>            :   end process;</a>
<a name="341"><span class="lineNum">     341 </span>            : </a>
<a name="342"><span class="lineNum">     342 </span><span class="lineCov">          4 :   coverage_output: process</span></a>
<a name="343"><span class="lineNum">     343 </span><span class="lineCov">          4 :     variable msg: msg_t;</span></a>
<a name="344"><span class="lineNum">     344 </span><span class="lineCov">          4 :     variable output_tran: output_tran_t;</span></a>
<a name="345"><span class="lineNum">     345 </span>            :   begin</a>
<a name="346"><span class="lineNum">     346 </span><span class="lineCov">          8 :     AddBins(cover_value, GenBin(0,255,4));</span></a>
<a name="347"><span class="lineNum">     347 </span><span class="lineCov">       1182 :     while true loop</span></a>
<a name="348"><span class="lineNum">     348 </span><span class="lineCov">       6324 :       receive(net, coverage_receiver_output, msg);</span></a>
<a name="349"><span class="lineNum">     349 </span><span class="lineCov">       1174 :       output_tran := pop(msg);</span></a>
<a name="350"><span class="lineNum">     350 </span><span class="lineCov">       7068 :       icover(cover_value, output_tran.value);</span></a>
<a name="351"><span class="lineNum">     351 </span>            :     end loop;</a>
<a name="352"><span class="lineNum">     352 </span>            :   end process;</a>
<a name="353"><span class="lineNum">     353 </span>            : </a>
<a name="354"><span class="lineNum">     354 </span>            : </a>
<a name="355"><span class="lineNum">     355 </span>            : end;</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
